unit jtagex;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, D2XXUNIT, StdCtrls, ExtCtrls, ComCtrls, JTAGDLLFuncUnit, FT2232HJTAGUnit,
  Spin;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    DeviceNameComboBox: TComboBox;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Panel2: TPanel;
    ComboBox3: TComboBox;
    Label6: TLabel;
    Button1: TButton;
    Edit2: TEdit;
    Label7: TLabel;
    Button2: TButton;
    Button3: TButton;
    Edit3: TEdit;
    Label8: TLabel;
    Memo1: TMemo;
    Button4: TButton;
    Button5: TButton;
    Panel3: TPanel;
    GPIOLPinsLabel: TLabel;
    GPIOLBit1OutputCheckBox: TCheckBox;
    GPIOLBit2OutputCheckBox: TCheckBox;
    GPIOLBit3OutputCheckBox: TCheckBox;
    GPIOLBit4OutputCheckBox: TCheckBox;
    GPIOLBitLabel: TLabel;
    GPIOLBit1Label: TLabel;
    GPIOLBit2Label: TLabel;
    GPIOLBit3Label: TLabel;
    GPIOLBit4Label: TLabel;
    GPIOLBit1HighCheckBox: TCheckBox;
    GPIOLBit2HighCheckBox: TCheckBox;
    GPIOLBit3HighCheckBox: TCheckBox;
    GPIOLBit4HighCheckBox: TCheckBox;
    GPIOLUpdateLowButton: TButton;
    GPIOLValueReadEdit: TEdit;
    GPIOLValueReadLabel: TLabel;
    Panel4: TPanel;
    GPIOHPinsLabel: TLabel;
    GPIOHBitLabel: TLabel;
    GPIOHBit1Label: TLabel;
    GPIOHBit2Label: TLabel;
    GPIOHBit3Label: TLabel;
    GPIOHBit4Label: TLabel;
    GPIOHValueReadLabel: TLabel;
    GPIOHBit1OutputCheckBox: TCheckBox;
    GPIOHBit2OutputCheckBox: TCheckBox;
    GPIOHBit3OutputCheckBox: TCheckBox;
    GPIOHBit4OutputCheckBox: TCheckBox;
    GPIOHBit1HighCheckBox: TCheckBox;
    GPIOHBit2HighCheckBox: TCheckBox;
    GPIOHBit3HighCheckBox: TCheckBox;
    GPIOHBit4HighCheckBox: TCheckBox;
    GPIOHUpdateLowButton: TButton;
    GPIOHValueReadEdit: TEdit;
    ExecuteButton: TButton;
    BufferScanCommandsCheckBox: TCheckBox;
    Panel5: TPanel;
    ClockPulsesLabel: TLabel;
    ClockPulsesButton: TButton;
    NumClockPulsesEdit: TEdit;
    GPIOHBit5Label: TLabel;
    GPIOHBit5OutputCheckBox: TCheckBox;
    GPIOHBit5HighCheckBox: TCheckBox;
    GPIOHBit6Label: TLabel;
    GPIOHBit6OutputCheckBox: TCheckBox;
    GPIOHBit6HighCheckBox: TCheckBox;
    GPIOHBit7Label: TLabel;
    GPIOHBit7OutputCheckBox: TCheckBox;
    GPIOHBit7HighCheckBox: TCheckBox;
    GPIOHBit8Label: TLabel;
    GPIOHBit8OutputCheckBox: TCheckBox;
    GPIOHBit8HighCheckBox: TCheckBox;
    HiSpeedDeviceTypeRadioGroup: TRadioGroup;
    FT2232HRadioButton: TRadioButton;
    FT4232HRadioButton: TRadioButton;
    procedure DeviceNameComboBoxDropDown(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure GPIOLUpdateLowButtonClick(Sender: TObject);
    procedure GPIOHUpdateLowButtonClick(Sender: TObject);
    procedure BufferScanCommandsCheckBoxClick(Sender: TObject);    
    procedure ExecuteButtonClick(Sender: TObject);
    procedure DeviceNameComboBoxChange(Sender: TObject);
    procedure ClockPulsesButtonClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
end;

  jtag_state     = (test_logic_reset, run_test_idle, pause_dr, pause_ir,
                     shift_dr, shift_ir, undefined_jtag_state);
  shift_register = (instruction_register,data_register);
  data_type      = array[0..$ffff] of byte;
  data_type_ptr  = ^data_type;
  Names = Array[1..20] of string;
  Names_Ptr = ^Names;

procedure DisplayFT2232HJTAGDllError(ProgFunctionName, DllFunctionName: String; ftStatus: FTC_STATUS);


var
  Form1: TForm1;

  My_Names : Names;
  PortAIsOpen : Boolean;
  OutIndex : integer;
  ImageData : ARRAY[0..63] of word;
  CalTime : boolean;
  SavedSpeed : string;
  SavedBits : string;

  UARTIsOpen : Boolean;
  FT_HANDLE_JTAG : DWord = 0;
  FT_HANDLE_UART : DWord = 0;


  //======================================================================
  current_state : jtag_state = undefined_jtag_state;
  data_out,data_in : array[0..$ffff] of byte;
  SavedLowVal : integer;
  SavedLowDir : integer;
  SavedHighVal : integer;
  SavedHighDir : integer;


  //======================================================================

const SpeedDivisorLabelDefaultText = 'Speed Divisor';

const USBBuffSize : integer = $8000;

  //======================================================================
  // go to ->                                    tlr rti pdr pir sdr sir
  //======================================================================
  from_test_logic_reset : array[0..5] of byte = ($01,$00,$0a,$16,$02,$06);
  from_run_test_idle : array[0..5] of byte    = ($07,$00,$05,$0b,$01,$03);
  from_pause_dr : array[0..5] of byte         = ($1f,$03,$17,$2f,$01,$0f);
  from_pause_ir : array[0..5] of byte         = ($1f,$03,$17,$2f,$07,$01);
  from_shift_dr : array[0..5] of byte         = ($1f,$03,$01,$2f,$00,$00);
  from_shift_ir : array[0..5] of byte         = ($1f,$03,$17,$01,$00,$00);
  //======================================================================
  // with this number of clocks
  //======================================================================
  from_test_logic_resetc : array[0..5] of byte = (1,1,5,6,4,5);
  from_run_test_idlec : array[0..5] of byte    = (3,5,4,5,3,4);
  from_pause_drc : array[0..5] of byte         = (5,3,6,7,2,6);
  from_pause_irc : array[0..5] of byte         = (5,3,6,7,5,2);
  from_shift_drc : array[0..5] of byte         = (5,3,2,7,0,0);
  from_shift_irc : array[0..5] of byte         = (5,4,6,2,0,0);

  ir_bdry_scan  = $00;
  ir_samp_scan  = $82;
  ir_bypass     = $04;

  //======================================================================


implementation

{$R *.dfm}


procedure DisplayFT2232HJTAGDllError(ProgFunctionName, DllFunctionName: String; ftStatus: FTC_STATUS);
var
  ErrorMsg: TErrorMessage;
begin
  FT2232HJTAG.GetErrorCodeString(ENGLISH, ftStatus, @ErrorMsg, MAX_NUM_ERROR_MESSAGE_CHARS);

  ShowMessage('Program function name = ' + ProgFunctionName +
              ', FT2232HJTAG Dll function name = ' + DllFunctionName +
              ', Error message = ' + ErrorMsg);
end;

function timeout_ms(start_time, end_time: TDateTime; timeout_val: integer): boolean;
var
  start_hour, start_min, start_sec, start_ms: word;
  end_hour,   end_min,   end_sec,   end_ms  : word;
begin
  decodetime(start_time, start_hour, start_min, start_sec, start_ms);
  decodetime(end_time,   end_hour,   end_min,   end_sec,   end_ms);
  end_min := end_min + (60 * (end_hour - start_hour));
  end_sec := end_sec + (60 * (end_min - start_min));
  end_ms  := end_ms  + (1000 * (end_sec - start_sec));
  timeout_ms := (end_ms - start_ms) >= timeout_val;
end;

procedure DispMsg(ts : string);
begin
form1.Memo1.Lines.Append(ts);
end;

function OpenPort(PortName : string) : boolean;
Var res : FT_Result;
NoOfDevs,i,J : integer;
Name : String;
DualName : string;
done : boolean;
begin
PortAIsOpen := False;
OpenPort := False;
Name := '';
Dualname := PortName;
res := GetFTDeviceCount;
if res <> Ft_OK then exit;
NoOfDevs := FT_Device_Count;
j := 0;
if NoOfDevs > 0 then
  begin
    repeat
      repeat
      res := GetFTDeviceDescription(J);
      if (res <> Ft_OK) then  J := J + 1;
      until (res = Ft_OK) OR (J=NoOfDevs);
    if res <> Ft_OK then exit;
    done := false;
    i := 1;
    Name := '';
      repeat
      if ORD(FT_Device_String_Buffer[i]) <> 0 then
        begin
        Name := Name + FT_Device_String_Buffer[i];
        end
      else
        begin
        done := true;
        end;
      i := i + 1;
      until done;
    J := J + 1;
    until (J = NoOfDevs) or (name = DualName);
  end;

if (name = DualName) then
  begin
  res := Open_USB_Device_By_Device_Description(name);
  if res <> Ft_OK then exit;
  OpenPort := true;
  res := Get_USB_Device_QueueStatus;
  if res <> Ft_OK then exit;
  PortAIsOpen := true;
  end
else
  begin
  OpenPort := false;
  end;

end;


procedure List_Devs( My_Names_Ptr : Names_Ptr);
Var res : FT_Result;
NoOfDevs,i,J,k : integer;
Name : String;
done : boolean;
begin
PortAIsOpen := False;
Name := '';
res := GetFTDeviceCount;
if res <> Ft_OK then exit;
NoOfDevs := FT_Device_Count;
j := 0;
k := 1;
if NoOfDevs > 0 then
  begin
    repeat
    res := GetFTDeviceDescription(J);
    if res = Ft_OK then
      begin
      done := false;
      i := 1;
      Name := '';
        repeat
        if ORD(FT_Device_String_Buffer[i]) <> 0 then
          begin
          Name := Name + FT_Device_String_Buffer[i];
          end
        else
          begin
          done := true;
          My_Names_Ptr[k]:= Name;
          k := k + 1;
          end;
        i := i + 1;
        until done;
      end;
    J := J + 1;
    until (J = NoOfDevs);
  end;

end;


procedure SendBytes(NumberOfBytes : integer);
var i : integer;
begin
i := Write_USB_Device_Buffer( NumberOfBytes);
OutIndex := OutIndex - i;
end;


procedure AddToBuffer(I:integer);
begin
FT_Out_Buffer[OutIndex]:= I AND $FF;
inc(OutIndex);
end;


function Check_For_Dev_A(Name : string) : boolean;
var len : integer;
SubString : string;
begin
Check_For_Dev_A := false;
if (Name <> '') then
  begin
  len := length(Name);
  if (len > 2) then
    begin
    SubString := Name[len-1] + Name[len];
    if (SubString = ' A') then Check_For_Dev_A := true;
    end;
  end;
end;

procedure GetNames;
Var i : integer;
Has_A : boolean;
DeviceIndex: Dword;
DeviceNames: TStringList;
begin
  for i := 1 to 20 do
    My_Names[i] := '';
  Form1.DeviceNameComboBox.Clear;

  if (FT2232HJTAGDll = True) then
  begin
    DeviceNames := TStringList.Create;

    if GetJTAGDeviceNames(DeviceNames) then
    begin
      for DeviceIndex := 0 to (DeviceNames.Count - 1) do
        Form1.DeviceNameComboBox.Items.Add(DeviceNames[DeviceIndex]);
    end;
  end
  else
  begin
    List_Devs(@My_Names);
    i := 1;
    if (My_Names[i] <> '' ) then
    begin
      repeat
        Has_A := Check_For_Dev_A(My_Names[i]);
        if Has_A then Form1.DeviceNameComboBox.Items.Add(My_Names[i]);
        i := i + 1;
      until (My_Names[i] = '');
    end;
  end;
end;


procedure ClosePort;
var
  res : FT_Result;
  DeviceHandleIndex: Dword;
  DeviceName: String;
  DeviceItemIndex: Dword;
begin
  if (FT2232HJTAGDll = True) then
  begin
    DeviceName := Form1.DeviceNameComboBox.Items.Strings[Form1.DeviceNameComboBox.ItemIndex];

    DeviceItemIndex := Form1.DeviceNameComboBox.ItemIndex;

    CloseJTAGDevice(DeviceName, DeviceItemIndex);

    PortAIsOpen := False;

    DeviceItemIndex := Form1.DeviceNameComboBox.ItemIndex;
    GetNames();
    Form1.DeviceNameComboBox.ItemIndex := DeviceItemIndex;

    Form1.BufferScanCommandsCheckBox.Checked := False;

    Form1.ClockPulsesLabel.Enabled := False;
    Form1.NumClockPulsesEdit.Enabled := False;
    Form1.ClockPulsesButton.Enabled := False;
  end
  else
  begin
  if PortAIsOpen then
    res := Close_USB_Device;

  PortAIsOpen := False;
  end;

  Form1.Label1.Caption := SpeedDivisorLabelDefaultText;
end;



//=========================================================
//== application things after here
//=========================================================

function HexWrdToStr(Dval : integer) : string;
var i : integer;
retstr : string;
begin
retstr := '';
i := (Dval AND $F000) DIV $1000;
case i of
  0 : retstr := retstr + '0';
  1 : retstr := retstr + '1';
  2 : retstr := retstr + '2';
  3 : retstr := retstr + '3';
  4 : retstr := retstr + '4';
  5 : retstr := retstr + '5';
  6 : retstr := retstr + '6';
  7 : retstr := retstr + '7';
  8 : retstr := retstr + '8';
  9 : retstr := retstr + '9';
  10 : retstr := retstr + 'A';
  11 : retstr := retstr + 'B';
  12 : retstr := retstr + 'C';
  13 : retstr := retstr + 'D';
  14 : retstr := retstr + 'E';
  15 : retstr := retstr + 'F';
end;
i := (Dval AND $F00) DIV $100;
case i of
  0 : retstr := retstr + '0';
  1 : retstr := retstr + '1';
  2 : retstr := retstr + '2';
  3 : retstr := retstr + '3';
  4 : retstr := retstr + '4';
  5 : retstr := retstr + '5';
  6 : retstr := retstr + '6';
  7 : retstr := retstr + '7';
  8 : retstr := retstr + '8';
  9 : retstr := retstr + '9';
  10 : retstr := retstr + 'A';
  11 : retstr := retstr + 'B';
  12 : retstr := retstr + 'C';
  13 : retstr := retstr + 'D';
  14 : retstr := retstr + 'E';
  15 : retstr := retstr + 'F';
end;
i := (Dval AND $F0) DIV $10;
case i of
  0 : retstr := retstr + '0';
  1 : retstr := retstr + '1';
  2 : retstr := retstr + '2';
  3 : retstr := retstr + '3';
  4 : retstr := retstr + '4';
  5 : retstr := retstr + '5';
  6 : retstr := retstr + '6';
  7 : retstr := retstr + '7';
  8 : retstr := retstr + '8';
  9 : retstr := retstr + '9';
  10 : retstr := retstr + 'A';
  11 : retstr := retstr + 'B';
  12 : retstr := retstr + 'C';
  13 : retstr := retstr + 'D';
  14 : retstr := retstr + 'E';
  15 : retstr := retstr + 'F';
end;
i := Dval AND $F;
case i of
  0 : retstr := retstr + '0';
  1 : retstr := retstr + '1';
  2 : retstr := retstr + '2';
  3 : retstr := retstr + '3';
  4 : retstr := retstr + '4';
  5 : retstr := retstr + '5';
  6 : retstr := retstr + '6';
  7 : retstr := retstr + '7';
  8 : retstr := retstr + '8';
  9 : retstr := retstr + '9';
  10 : retstr := retstr + 'A';
  11 : retstr := retstr + 'B';
  12 : retstr := retstr + 'C';
  13 : retstr := retstr + 'D';
  14 : retstr := retstr + 'E';
  15 : retstr := retstr + 'F';
end;
HexWrdToStr := retstr;
end;


function HexNibToStr(Dval : integer) : string;
var i : integer;
retstr : string;
begin
retstr := '';
i := Dval AND $F;
case i of
  0 : retstr := retstr + '0';
  1 : retstr := retstr + '1';
  2 : retstr := retstr + '2';
  3 : retstr := retstr + '3';
  4 : retstr := retstr + '4';
  5 : retstr := retstr + '5';
  6 : retstr := retstr + '6';
  7 : retstr := retstr + '7';
  8 : retstr := retstr + '8';
  9 : retstr := retstr + '9';
  10 : retstr := retstr + 'A';
  11 : retstr := retstr + 'B';
  12 : retstr := retstr + 'C';
  13 : retstr := retstr + 'D';
  14 : retstr := retstr + 'E';
  15 : retstr := retstr + 'F';
end;
HexNibToStr := retstr;
end;




//======================================================================
// add to memo box
//======================================================================

procedure showdata(rcvddata : integer);
var CharH,CharL : Char;
i : integer;
begin
i := (RcvdData AND $FF00) DIV 256;
if (i > $2F) AND (i <$7F) then
  begin
  CharH := chr(i);
  end
else
  begin
  CharH := '.';
  end;
i := RcvdData AND $FF;
if (i > $2F) AND (i <$7F) then
  begin
  CharL := chr(i);
  end
else
  begin
  CharL := '.';
  end;

form1.Memo1.Lines.Append(HexWrdtostr(RcvdData)+' '+CharH+CharL);
end;

//======================================================================
// purge data buffer
//======================================================================
procedure PurgeChip;
var res : FT_Result;
 j : integer;
begin
res := Reset_USB_Device;
// check for old data
res := Get_USB_Device_QueueStatus;
if FT_Q_Bytes > 0 then
  j := Read_USB_Device_Buffer(FT_Q_Bytes);
end;


procedure waitDelay;
begin
end;

procedure SndImmediate;
begin
OutIndex := 0;
AddToBuffer($87); // Send Immediate
SendBytes(OutIndex); // send off the command
end;


procedure LoopBackOn;
begin
OutIndex := 0;
AddToBuffer($84);
SendBytes(OutIndex); // send off the command
end;

procedure LoopBackOff;
begin
OutIndex := 0;
AddToBuffer($85);
SendBytes(OutIndex); // send off the command
end;

//======================================================================
//== JTAG state transition code
//======================================================================

procedure wiggler_do_tms(tmsval,count : byte;Do_Read : boolean);
begin
if count = 0 then exit;
if count > 7 then exit;
if Do_Read then AddToBuffer($6B) else AddToBuffer($4B);
AddToBuffer(count-1);
AddToBuffer(tmsval);
end;

function wiggler_move_state(new_state : jtag_state;last_data : byte;Do_Read : boolean) : integer;
//
// this returns the number of TMS clocks to work out the last bit of TDO
//
begin
if current_state = undefined_jtag_state then
  begin
  wiggler_do_tms($7F,7,false);
  current_state := test_logic_reset;
  end;

wiggler_move_state := 0;

case current_state of
  test_logic_reset:
    begin
    wiggler_do_tms(from_test_logic_reset[byte(new_state)] or (last_data SHL 7),
      from_test_logic_resetc[byte(new_state)],Do_Read);
    wiggler_move_state := from_test_logic_resetc[byte(new_state)];
    end;
  run_test_idle:
    begin
    wiggler_do_tms(from_run_test_idle[byte(new_state)] or (last_data SHL 7),
      from_run_test_idlec[byte(new_state)],Do_Read);
    wiggler_move_state := from_run_test_idlec[byte(new_state)];
    end;
  pause_dr:
    begin
    wiggler_do_tms(from_pause_dr[byte(new_state)] or (last_data SHL 7),
      from_pause_drc[byte(new_state)],Do_Read);
    wiggler_move_state := from_pause_drc[byte(new_state)];
    end;
  pause_ir:
    begin
    wiggler_do_tms(from_pause_ir[byte(new_state)] or (last_data SHL 7),
      from_pause_irc[byte(new_state)],Do_Read);
    wiggler_move_state := from_pause_irc[byte(new_state)];
    end;
  shift_dr:
    begin
    wiggler_do_tms(from_shift_dr[byte(new_state)] or (last_data SHL 7),
      from_shift_drc[byte(new_state)],Do_Read);
    wiggler_move_state := from_shift_drc[byte(new_state)];
    end;
  shift_ir:
    begin
    wiggler_do_tms(from_shift_ir[byte(new_state)] or (last_data SHL 7),
      from_shift_irc[byte(new_state)],Do_Read);
    wiggler_move_state := from_shift_irc[byte(new_state)];
    end;
  end;
current_state := new_state;
end;

//======================================================================
//== End Of JTAG state transition code
//======================================================================

//=======================================================
// Routines to Control MPSSE hardware
//=======================================================

function Get_Data(in_data : data_type_ptr;Bit_Length : integer;
                   TMS_Clks : integer) : boolean;
//
// This will work out the number of whole bytes to read and adjust
// for the TMS read
//
var res : FT_Result;
NoBytes,i,j : integer;
BitShift,Mod_Bit_Length : integer;
Last_Bit : byte;
Temp_Buffer : array[0..64000] of byte;
TotalBytes : integer;
timeout_start: TDateTime;
timeout_end  : TDateTime;
timeout     : boolean;
begin
Get_Data := false;
i := 0;
Mod_Bit_Length := Bit_Length - 1; // adjust for bit count of 1 less than no of bits
NoBytes := Mod_Bit_Length DIV 8;  // get whole bytes
BitShift := Mod_Bit_Length MOD 8; // get remaining bits
if BitShift > 0 then NoBytes := NoBytes + 1; // bump whole bytes if bits left over
BitShift := 8 - BitShift; // adjust for SHR of incoming byte
NoBytes := NoBytes + 1; // add 1 for TMS read byte
i := 0;
TotalBytes := 0;
repeat
  timeout_start := now;
  repeat
    res := Get_USB_Device_QueueStatus;
    if ( FT_Q_Bytes = 0) then sleep(0); // give up timeslice
    timeout_end := now;
    timeout := timeout_ms(timeout_start, timeout_end, 5000);
  until (FT_Q_Bytes > 0) or (res <> FT_OK) or timeout;
  if (FT_Q_Bytes > 0) then
    begin
    j := Read_USB_Device_Buffer(FT_Q_Bytes);
    for i := 0 to (j-1) do
      begin
      Temp_Buffer[TotalBytes] := FT_In_Buffer[i];
      TotalBytes := TotalBytes + 1;
      end;
    end;
until (TotalBytes >= NoBytes) or (res <> FT_OK) or timeout;

if not(timeout) and (res = FT_OK) then
  begin
  Get_Data := true;
  //adjust last 2 bytes
  if (BitShift < 8 ) THEN
    begin
    Temp_Buffer[NoBytes-2] := Temp_Buffer[NoBytes-2] SHR BitShift;
    Last_Bit := Temp_Buffer[NoBytes-1] SHL (TMS_Clks-1);
    Last_Bit := Last_Bit AND $80; // strip the rest
    Temp_Buffer[NoBytes-2] := Temp_Buffer[NoBytes-2] OR (Last_Bit SHR (BitShift-1));
    for j := 0 to (NoBytes-2) do
      begin
      in_data[j] := Temp_Buffer[j];
      end;
    end
  else // case for 0 bit shift in data + TMS read bit
    begin
    Last_Bit := Temp_Buffer[NoBytes-1] SHL (TMS_Clks-1);
    Last_Bit := Last_Bit SHR 7; // strip the rest
    Temp_Buffer[NoBytes-1] := Last_Bit;
    for j := 0 to (NoBytes-1) do
      begin
      in_data[j] := Temp_Buffer[j];
      end;
    end;
  end;
end;

procedure s_out(jtag_register : shift_register; bit_length : integer;
                   out_data : data_type_ptr; state : jtag_state);
//
// JTAG Scan out
//
var i,j,TMS_Clks : integer;
LastBit : byte;
Mod_bit_length : integer;
Do_Read : boolean;
bInstructionTestData: LongBool;
ftStatus: FTC_STATUS;
WriteDataBuffer: WriteDataByteBuffer;
NumBytesToWrite, OutDataIndex: Dword;
begin
if PortAIsOpen then
begin
  if (FT2232HJTAGDll = True) then
  begin
    bInstructionTestData := False;
    if (jtag_register = instruction_register) then
      bInstructionTestData := True;

    NumBytesToWrite := (bit_length div 8);
    if (bit_length mod 8 > 0) then
      Inc(NumBytesToWrite);

    for OutDataIndex := 0 to (NumBytesToWrite - 1) do
      WriteDataBuffer[OutDataIndex] := out_data[OutDataIndex];

    JTAGScanOut(Form1.BufferScanCommandsCheckBox.Checked, bInstructionTestData, bit_length,
                @WriteDataBuffer, NumBytesToWrite);
  end
  else
  begin
  OutIndex := 0;
  j := 0;
  Mod_bit_length := bit_length - 1;
  Do_Read := false;
  if (jtag_register = instruction_register) then
    TMS_Clks := wiggler_move_state(shift_ir,0,Do_Read)
  else
    TMS_Clks := wiggler_move_state(shift_dr,0,Do_Read);

  if Mod_bit_length div 8 > 0 then
    begin // do whole bytes
    i := (Mod_bit_length div 8) - 1;
    AddToBuffer($19); // clk data bytes out on -ve clk LSB
    AddToBuffer(i AND $FF);
    AddToBuffer((i DIV 256) AND $FF);
    // now add the data bytes to go out
      repeat
      AddToBuffer(out_data[j]);
      j := j + 1;
      until j > i;
    end;
  if Mod_bit_length mod 8 > 0 then
    begin // do remaining bits
    i := (Mod_bit_length mod 8) - 1;
    AddToBuffer($1B); // clk data bits out on -ve clk LSB
    AddToBuffer(i AND $FF);
    // now add the data bits to go out
    AddToBuffer(out_data[j]);
    end;
  // get LastBit
  LastBit := out_data[j];
  j := bit_length mod 8;
  LastBit := LastBit SHR (8-j-1);
  TMS_Clks := wiggler_move_state(state,LastBit,Do_Read); // end it in state passed in
  SendBytes(OutIndex); // send off the command
  end;
end;
end;

procedure s_io(jtag_register : shift_register;
                  bit_length : integer; out_data, in_data : data_type_ptr;
                  state : jtag_state;SendImmediate : boolean );
//
// JTAG Scan in and out
//
var i,j,TMS_Clks : integer;
LastBit : byte;
Mod_bit_length : integer;
Do_Read,passed : boolean;
bInstructionTestData: LongBool;
WriteDataBuffer: WriteDataByteBuffer;
NumBytesToWrite, OutDataIndex: Dword;
ReadDataBuffer: ReadDataByteBuffer;
NumBytesReturned, InDataIndex: Dword;
begin
if PortAIsOpen then
begin
  if (FT2232HJTAGDll = True) then
  begin
    bInstructionTestData := False;
    if (jtag_register = instruction_register) then
      bInstructionTestData := True;

    NumBytesToWrite := (bit_length div 8);
    if (bit_length mod 8 > 0) then
      Inc(NumBytesToWrite);

    for OutDataIndex := 0 to (NumBytesToWrite - 1) do
      WriteDataBuffer[OutDataIndex] := out_data[OutDataIndex];

    passed := JTAGScanInOut(Form1.BufferScanCommandsCheckBox.Checked, bInstructionTestData, bit_length, @WriteDataBuffer, NumBytesToWrite, @ReadDataBuffer, @NumBytesReturned);

    if (Passed and (not Form1.BufferScanCommandsCheckBox.Checked)) then
    begin
      if (NumBytesReturned > 0) then
      begin
        for InDataIndex := 0 to (NumBytesReturned - 1) do
          in_data[InDataIndex] := ReadDataBuffer[InDataIndex];
      end;
    end;
  end
  else
  begin
  OutIndex := 0;
  j := 0;
  Mod_bit_length := bit_length - 1;
  Do_Read := false;
  if (jtag_register = instruction_register) then
    TMS_Clks := wiggler_move_state(shift_ir,0,Do_Read)
  else
    TMS_Clks := wiggler_move_state(shift_dr,0,Do_Read);

  if Mod_bit_length div 8 > 0 then
    begin // do whole bytes
    i := (Mod_bit_length div 8) - 1;
    AddToBuffer($39); // clk data bytes out on -ve in +ve clk LSB
    AddToBuffer(i AND $FF);
    AddToBuffer((i DIV 256) AND $FF);
    // now add the data bytes to go out
      repeat
      AddToBuffer(out_data[j]);
      j := j + 1;
      until j > i;
    end;
  if Mod_bit_length mod 8 > 0 then
    begin // do remaining bits
    i := (Mod_bit_length mod 8) - 1;
    AddToBuffer($3B); // clk data bits out on -ve in +ve clk LSB
    AddToBuffer(i AND $FF);
    // now add the data bits to go out
    AddToBuffer(out_data[j]);
    end;
  // get LastBit
  LastBit := out_data[j];
  j := bit_length mod 8;
  LastBit := LastBit SHR (8-j-1);
  Do_Read := true;
  TMS_Clks := wiggler_move_state(state,LastBit,Do_Read); // end it in state passed in
  if SendImmediate then AddToBuffer($87);
  SendBytes(OutIndex); // send off the command
  // now wait for data
  passed := Get_Data(in_data,Bit_Length,TMS_Clks);
  //
  end;
end;
end;

procedure s_in(jtag_register : shift_register; bit_length : integer;
                   in_data : data_type_ptr; state : jtag_state;
                   TDILevel : byte;SendImmediate : boolean);
//
// JTAG Scan in
//
var i,TMS_Clks : integer;
Mod_bit_length : integer;
Do_Read : boolean;
Passed : boolean;
bInstructionTestData: LongBool;
ReadDataBuffer: ReadDataByteBuffer;
NumBytesReturned, InDataIndex: Dword;
begin
if PortAIsOpen then
begin
  if (FT2232HJTAGDll = True) then
  begin
    bInstructionTestData := False;
    if (jtag_register = instruction_register) then
      bInstructionTestData := True;

    Passed := JTAGScanIn(Form1.BufferScanCommandsCheckBox.Checked, bInstructionTestData, bit_length, @ReadDataBuffer, @NumBytesReturned);

    if (Passed and (not Form1.BufferScanCommandsCheckBox.Checked)) then
    begin
      for InDataIndex := 0 to (NumBytesReturned - 1) do
        in_data[InDataIndex] := ReadDataBuffer[InDataIndex];
    end;
  end
  else
  begin
  OutIndex := 0;
  Mod_bit_length := bit_length - 1;
  Do_Read := false;
  if (jtag_register = instruction_register) then
    TMS_Clks := wiggler_move_state(shift_ir,TDILevel,Do_Read)
  else
    TMS_Clks := wiggler_move_state(shift_dr,TDILevel,Do_Read);

  if Mod_bit_length div 8 > 0 then
    begin // do whole bytes
    i := (Mod_bit_length div 8) - 1;
    AddToBuffer($28); // clk data bytes in LSB +ve clk
    AddToBuffer(i AND $FF);
    AddToBuffer((i DIV 256) AND $FF);
    end;
  if Mod_bit_length mod 8 > 0 then
    begin // do remaining bits
    i := (Mod_bit_length mod 8) - 1;
    AddToBuffer($2A); // clk data bits in LSB +ve clk
    AddToBuffer(i AND $FF);
    end;
  Do_Read := true;
  TMS_Clks := wiggler_move_state(state,TDILevel,Do_Read); // end it in state passed in
  if SendImmediate then AddToBuffer($87);
  SendBytes(OutIndex); // send off the command
  // now wait for data
  passed := Get_Data(in_data,Bit_Length,TMS_Clks);
  end;
end;
end;

procedure W_LowPins(Valpin,DirPin : byte);
var i : byte;
begin
if PortAIsOpen then
  begin
  OutIndex := 0;
  AddToBuffer($80); // output  on GPIO L1-4
  SavedLowVal := SavedLowVal AND $F;
  SavedLowDir := SavedLowDir AND $F;
  i := ValPin AND $F;
  SavedLowVal := SavedLowVal or (i * $10);
  i := DirPin AND $F;
  SavedLowDir := SavedLowDir or (i * $10);
  AddToBuffer(SavedLowVal);
  AddToBuffer(SavedLowDir); // direction
  SendBytes(OutIndex); // send off the command
  end;
end;


procedure W_HighPins(Valpin,DirPin : byte);
var i : byte;
begin
if PortAIsOpen then
  begin
  OutIndex := 0;
  AddToBuffer($82); // output  on GPIO H1-4
  i := ValPin AND $F;
  AddToBuffer(i);
  i := DirPin AND $F;
  AddToBuffer(i); // direction
  SendBytes(OutIndex); // send off the command
  end;
end;

function R_LowInputs : byte;
var res : FT_Result;
i,j : integer;
timeout_start: TDateTime;
timeout_end  : TDateTime;
timeout     : boolean;
begin
R_LowInputs := $00;
if PortAIsOpen then
  begin
  OutIndex := 0;
  AddToBuffer($81); // inputs on GPIOL 1-4
  AddToBuffer($87); // send immediate
  SendBytes(OutIndex); // send off the command
  // now wait for data
  timeout_start := now;
  repeat
    res := Get_USB_Device_QueueStatus;
    if ( FT_Q_Bytes = 0) then sleep(0); // give up timeslice
    timeout_end := now;
    timeout := timeout_ms(timeout_start, timeout_end, 5000);
  until (FT_Q_Bytes >= 1) or (res <> FT_OK) or timeout;

  IF (FT_Q_Bytes > 0) then
    begin
    i := Read_USB_Device_Buffer(FT_Q_Bytes);
    i := FT_In_Buffer[0] SHR 4;
    R_LowInputs := i AND $0F;
    end;
  end;
end;


function R_HighInputs : byte;
var res : FT_Result;
i,j : integer;
timeout_start: TDateTime;
timeout_end  : TDateTime;
timeout     : boolean;
begin
R_HighInputs := $00;
if PortAIsOpen then
  begin
  OutIndex := 0;
  AddToBuffer($83); // inputs on GPIOH 1-4
  AddToBuffer($87); // send immediate
  SendBytes(OutIndex); // send off the command
  // now wait for data
  timeout_start := now;
  repeat
    res := Get_USB_Device_QueueStatus;
    if ( FT_Q_Bytes = 0) then sleep(0); // give up timeslice
    timeout_end := now;
    timeout := timeout_ms(timeout_start, timeout_end, 5000);
  until (FT_Q_Bytes >= 1) or (res <> FT_OK) or timeout;

  IF (FT_Q_Bytes > 0) then
    begin
    i := Read_USB_Device_Buffer(FT_Q_Bytes);
    i := FT_In_Buffer[0];
    R_HighInputs := i AND $0F;
    end;
  end;
end;

function InSync : boolean;
var res : FT_Result;
j : integer;
begin
InSync := false;
OutIndex := 0;
AddToBuffer($bb);
SendBytes(OutIndex); // send off the command
  repeat
    res := Get_USB_Device_QueueStatus;
  until FT_Q_Bytes > 0;
  j := Read_USB_Device_Buffer(FT_Q_Bytes);
end;

function Init_Controller(speed : word) : boolean;
var passed : boolean;
res : FT_Result;
DeviceName : String;
begin
Init_Controller := false;
form1.Memo1.Clear;
form1.Memo1.Update;
DeviceName := Form1.DeviceNameComboBox.Text;
passed := false;
if (DeviceName <> '') then
  begin
  passed := OpenPort(DeviceName);
  end
else
  begin
  DispMsg('no valid device selected in drop down window');
  end;
if Passed then
  begin
  PurgeChip;

  res := Set_USB_Device_LatencyTimer(16);
  res := Set_USB_Device_BitMode($00,$00); // reset controller
  res := Set_USB_Device_BitMode($00,$02); // enable JTAG controller

  PurgeChip;
  OutIndex := 0;

  sleep(20); // wait for all the USB stuff to complete

  AddToBuffer($80); // set I/O low bits all out except TDO
  SavedLowVal := SavedLowVal AND $F0;
  SavedLowVal := SavedLowVal OR $08; // TDI,TCK start low
  AddToBuffer(SavedLowVal);
  SavedLowDir := SavedLowDir AND $F0;
  SavedLowDir := SavedLowDir OR $0B;
  AddToBuffer(SavedLowDir);
  AddToBuffer($82); // output on GPIOH 1-4
  AddToBuffer(SavedHighVal);
  AddToBuffer(SavedHighDir);
  AddToBuffer($86); // set clk divisor
  AddToBuffer(speed AND $FF);
  AddToBuffer(speed SHR 8);
  // turn off loop back
  AddToBuffer($85);

  SendBytes(OutIndex); // send off the command
  Init_Controller := passed;
  end;
end;

procedure Rst_tap(state : jtag_state);
var Do_Read : boolean;
TMS_Clks : integer;
begin
if PortAIsOpen then
  begin
  sleep(20); // wait for all the USB stuff to complete
  PurgeChip;
  sleep(20); // wait for all the USB stuff to complete
  OutIndex := 0;
  AddToBuffer($80); // set I/O low bits all out except TDO
  SavedLowVal := SavedLowVal AND $F0;
  SavedLowVal := SavedLowVal OR $08; // TDI,TCK start low
  AddToBuffer(SavedLowVal);
  SavedLowDir := SavedLowDir AND $F0;
  SavedLowDir := SavedLowDir OR $0B;
  AddToBuffer(SavedLowDir);
  current_state := undefined_jtag_state;
  Do_Read := false;
  TMS_Clks := wiggler_move_state(test_logic_reset,1,Do_Read);
  TMS_Clks := wiggler_move_state(state,0,Do_Read);
  SendBytes(OutIndex); // send off the command
  PurgeChip;
  end;
end;

//=======================================================
// End - Routines to Control MPSSE hardware
//=======================================================

procedure TForm1.DeviceNameComboBoxDropDown(Sender: TObject);
begin
GetNames;
end;

function NibbleToHex(charStr : string) : byte;
var tmpint : byte;
begin
tmpint := 0;
if CharStr = '0' then tmpint := 0;
if CharStr =  '1' then tmpint := 1;
if CharStr =  '2' then tmpint := 2;
if CharStr =  '3' then tmpint := 3;
if CharStr =  '4' then tmpint := 4;
if CharStr =  '5' then tmpint := 5;
if CharStr =  '6' then tmpint := 6;
if CharStr =  '7' then tmpint := 7;
if CharStr =  '8' then tmpint := 8;
if CharStr =  '9' then tmpint := 9;
if CharStr =  'A' then tmpint := 10;
if CharStr =  'B' then tmpint := 11;
if CharStr =  'C' then tmpint := 12;
if CharStr =  'D' then tmpint := 13;
if CharStr =  'E' then tmpint := 14;
if CharStr =  'F' then tmpint := 15;
if CharStr =  'a' then tmpint := 10;
if CharStr =  'b' then tmpint := 11;
if CharStr =  'c' then tmpint := 12;
if CharStr =  'd' then tmpint := 13;
if CharStr =  'e' then tmpint := 14;
if CharStr =  'f' then tmpint := 15;
NibbleToHex := tmpint;

end;

function StrToHex(c4harStr : String) : integer;
var tmpint,I,J : integer;
nibbleStr : String;
begin
tmpint := 0;
I := Length(c4harStr);
J := 0;
repeat
  nibbleStr := C4harStr[J+1];
  if (nibbleStr <> ' ') then
    begin
      tmpint := (tmpint*16) + NibbleToHex(nibbleStr);
    end;
  J := J + 1;
until J = I;
StrToHex := tmpint;
end;


procedure ProcessForm(var jtag_register : shift_register;
                      var bit_length : integer;
                      var state : jtag_state;
                      var TDILevel : byte);
var i : integer;
begin
if (form1.ComboBox3.ItemIndex = 1) then
  jtag_register := instruction_register
else
  jtag_register := data_register;

bit_length := strtoint(Trim(form1.Edit3.Text));

state := run_test_idle;

TDILevel := 0;

//parse   data
i := StrToHex(Trim(form1.Edit2.Text));
data_out[0] := i AND $FF;
data_out[1] := (i AND $FF00) div $100;
data_out[2] := (i AND $FF0000) div $10000;
data_out[3] := (i AND $FF000000) div $1000000;

end;



Procedure ScanIn;
var jtag_register : shift_register;
bit_length : integer;
state : jtag_state;
TDILevel : byte;
SendImmediate : boolean;

begin
if PortAIsOpen then
  begin
  if (not Form1.BufferScanCommandsCheckBox.Checked) then
    DispMsg('Doing a Scan In')
  else
    DispMsg('Added Scan In');

  ProcessForm(jtag_register,bit_length,state,TDILevel);
  SendImmediate := true;
  s_in(jtag_register,bit_length,@data_in[0],state,TDILevel,SendImmediate);

  if (not Form1.BufferScanCommandsCheckBox.Checked) then
    DispMsg('Read back : '+ HexByteToStr(data_in[3]) +' '+
                            HexByteToStr(data_in[2]) +' '+
                            HexByteToStr(data_in[1]) +' '+
                            HexByteToStr(data_in[0]));
  end
else
  begin
  DispMsg('Device is not open');
  end;
end;

Procedure ScanInOut;
var jtag_register : shift_register;
bit_length : integer;
state : jtag_state;
TDILevel : byte;
SendImmediate : boolean;

begin
if PortAIsOpen then
  begin
  if (not Form1.BufferScanCommandsCheckBox.Checked) then
    DispMsg('Doing a Scan In and Out')
  else
    DispMsg('Added Scan In and Out');

  ProcessForm(jtag_register,bit_length,state,TDILevel);
  SendImmediate := true;
  s_io(jtag_register,bit_length,@data_out[0],@data_in[0],state,SendImmediate);

  if (not Form1.BufferScanCommandsCheckBox.Checked) then
    DispMsg('Read back : '+ HexByteToStr(data_in[3]) +' '+
                            HexByteToStr(data_in[2]) +' '+
                            HexByteToStr(data_in[1]) +' '+
                            HexByteToStr(data_in[0]));

  end
else
  begin
  DispMsg('Device is not open');
  end;
end;


Procedure ScanOut;
var jtag_register : shift_register;
bit_length : integer;
state : jtag_state;
TDILevel : byte;

begin
if PortAIsOpen then
  begin
  if (not Form1.BufferScanCommandsCheckBox.Checked) then
    DispMsg('Doing a Scan Out')
  else
    DispMsg('Added Scan Out');
    
  ProcessForm(jtag_register,bit_length,state,TDILevel);
  s_out(jtag_register,bit_length,@data_out[0],state);

  end
else
  begin
  DispMsg('Device is not open');
  end;
end;


procedure TForm1.Edit1Change(Sender: TObject);
var
  i : integer;
  ftStatus: FTC_STATUS;
  ClockDivisor, ClockFrequencyHz: Dword;
begin
try
i := strtoint(form1.edit1.Text);

  if PortAIsOpen then
  begin
    if (FT2232HJTAGDll = True) then
    begin
      ClockDivisor := i;

      ftStatus := FT2232HJTAG.SetClock(ftHandle, ClockDivisor, @ClockFrequencyHz);

      if (ftStatus = FTC_SUCCESS) then
        Form1.Label1.Caption := SpeedDivisorLabelDefaultText + '(' + IntToStr(ClockFrequencyHz) + 'Hz)'
      else
        DisplayFT2232HJTAGDllError('Edit1Change', 'SetClock', ftStatus);
    end;
  end;
except
form1.Edit1.Text := savedspeed;
end;

end;

procedure TForm1.FormCreate(Sender: TObject);
var
  DeviceHandleIndex: Dword;
begin
  savedspeed := '0';
  SavedBits :='32';
  SavedLowVal := 0;
  SavedLowDir := 0;
  SavedHighVal := 0;
  SavedHighDir := 0;

  FT2232HJTAGDll := True;
  FT2232HJTAG := TFT2232HJTAG.Create;
  ExecuteButton.Enabled := False;

  for DeviceHandleIndex := 0 to 49 do
  begin
    HiSpeedDevices[DeviceHandleIndex].ftHandle := 0;
    HiSpeedDevices[DeviceHandleIndex].DeviceName := '';
    DeviceBitLengths[DeviceHandleIndex].NumBitLengths := 0;
  end;

  NumOpenedDevices := 0;

  Form1.ClockPulsesLabel.Enabled := False;
  Form1.NumClockPulsesEdit.Enabled := False;
  Form1.NumClockPulsesEdit.Text := '10';
  Form1.ClockPulsesButton.Enabled := False;
end;

procedure TForm1.Edit3Change(Sender: TObject);
var i : integer;
begin
try
i := strtoint(form1.edit3.Text);
except
form1.Edit3.Text := savedbits;
end;
end;

procedure OpenDevice;
var speed : word;
passed : boolean;
ftStatus: FTC_STATUS;
DeviceName: String;
LocationID: Dword;
ClockDivisor, ClockFrequencyHz: Dword;
DeviceHandleIndex: Dword;
OpenedDeviceName: String;
begin
  form1.Memo1.Clear;
  form1.Memo1.Update;
  if (FT2232HJTAGDll = True) then
  begin
    DeviceName := Form1.DeviceNameComboBox.Text;

    if (DeviceName <> '') then
    begin
      ClockDivisor := strtoint(Trim(form1.Edit1.Text));

      if OpenJTAGDevice(DeviceName, ClockDivisor) then
      begin
        PortAIsOpen := true;

        FT2232HJTAG.GetClock(ClockDivisor, @ClockFrequencyHz);
        Form1.Label1.Caption := SpeedDivisorLabelDefaultText + '(' + IntToStr(ClockFrequencyHz) + 'Hz)';

        Form1.ClockPulsesLabel.Enabled := True;
        Form1.NumClockPulsesEdit.Enabled := True;
        Form1.ClockPulsesButton.Enabled := True;

        DispMsg('Open success');
      end;
    end
    else
      DispMsg('no valid device selected in drop down window');
  end
  else
  begin
    SavedSpeed := form1.Edit1.Text;
    Form1.Memo1.Clear;
    DispMsg('Opening device');
    speed := strtoint(form1.Edit1.Text);
    passed := Init_Controller(speed);
    if passed then
    begin
      DispMsg('Open success');
      DispMsg('Resetting TAP controller');
      Rst_tap(run_test_idle); // reset TAP controller and put it in
                              // run test idle
    end
    else
    begin
      DispMsg('Open failed');
    end;
  end;
end;

procedure UpdateLowIO;
var
  ValPin,DirPin : byte;
  LowInputOutputPins: FtcInputOutputPins;
  HighInputOutputPins: FthInputOutputPins;
  LowPinsInputData: FtcLowHighPins;
  HighPinsInputData: FthLowHighPins;
  ftStatus: FTC_STATUS;
begin
if PortAIsOpen then
  begin
  DispMsg('Writing value to GPIOL 1-4');
  if (FT2232HJTAGDll = True) then
  begin
    LowInputOutputPins.Pin1InputOutputState := form1.GPIOLBit1OutputCheckBox.Checked;
    LowInputOutputPins.Pin1LowHighState := form1.GPIOLBit1HighCheckBox.Checked;
    LowInputOutputPins.Pin2InputOutputState := form1.GPIOLBit2OutputCheckBox.Checked;
    LowInputOutputPins.Pin2LowHighState := form1.GPIOLBit2HighCheckBox.Checked;
    LowInputOutputPins.Pin3InputOutputState := form1.GPIOLBit3OutputCheckBox.Checked;
    LowInputOutputPins.Pin3LowHighState := form1.GPIOLBit3HighCheckBox.Checked;
    LowInputOutputPins.Pin4InputOutputState := form1.GPIOLBit4OutputCheckBox.Checked;
    LowInputOutputPins.Pin4LowHighState := form1.GPIOLBit4HighCheckBox.Checked;

    ftStatus := FT2232HJTAG.SetHiSpeedDeviceGPIOs(ftHandle, True, @LowInputOutputPins,
                                                  False, @HighInputOutputPins);

    if (ftStatus = FTC_SUCCESS) then
    begin
      DispMsg('Reading value from GPIOL 1-4');
      ftStatus := FT2232HJTAG.GetHiSpeedDeviceGPIOs(fthandle, True, @LowPinsInputData,
                                                    False, @HighPinsInputData);
                                       
      if (ftStatus = FTC_SUCCESS) then
      begin
        ValPin := 0;
        if LowPinsInputData.Pin1LowHighState then
          ValPin := ValPin or $01;
        if LowPinsInputData.Pin2LowHighState then
          ValPin := ValPin or $02;
        if LowPinsInputData.Pin3LowHighState then
          ValPin := ValPin or $04;
        if LowPinsInputData.Pin4LowHighState then
          ValPin := ValPin or $08;
      end
      else
        DisplayFT2232HJTAGDllError('UpdateLowIO', 'GetGPIOs', ftStatus);
    end
    else
      DisplayFT2232HJTAGDllError('UpdateLowIO', 'SetGPIOs', ftStatus);
  end
  else
  begin
  ValPin := 0;
  DirPin := 0;
  if form1.GPIOLBit1HighCheckBox.Checked then ValPin := ValPin or $01;
  if form1.GPIOLBit2HighCheckBox.Checked then ValPin := ValPin or $02;
  if form1.GPIOLBit3HighCheckBox.Checked then ValPin := ValPin or $04;
  if form1.GPIOLBit4HighCheckBox.Checked then ValPin := ValPin or $08;
  if form1.GPIOLBit1OutputCheckBox.Checked then DirPin := DirPin or $01;
  if form1.GPIOLBit2OutputCheckBox.Checked then DirPin := DirPin or $02;
  if form1.GPIOLBit3OutputCheckBox.Checked then DirPin := DirPin or $04;
  if form1.GPIOLBit4OutputCheckBox.Checked then DirPin := DirPin or $08;
  W_LowPins(Valpin,DirPin);
  DispMsg('Reading value from GPIOL 1-4');
  ValPin := R_LowInputs;
  end;
  form1.GPIOLValueReadEdit.Text := HexNibToStr(ValPin);
  end
else
  begin
  DispMsg('Device is not open');
  end;
end;


procedure UpdateHighIO;
var
  ValPin,DirPin : byte;
  LowInputOutputPins: FtcInputOutputPins;
  HighInputOutputPins: FthInputOutputPins;
  LowPinsInputData: FtcLowHighPins;
  HighPinsInputData: FthLowHighPins;
  ftStatus: FTC_STATUS;  
begin
if PortAIsOpen then
  begin
  DispMsg('Writing value to GPIOH 1-8');
  if (FT2232HJTAGDll = True) then
  begin
    HighInputOutputPins.Pin1InputOutputState := form1.GPIOHBit1OutputCheckBox.Checked;
    HighInputOutputPins.Pin1LowHighState := form1.GPIOHBit1HighCheckBox.Checked;
    HighInputOutputPins.Pin2InputOutputState := form1.GPIOHBit2OutputCheckBox.Checked;
    HighInputOutputPins.Pin2LowHighState := form1.GPIOHBit2HighCheckBox.Checked;
    HighInputOutputPins.Pin3InputOutputState := form1.GPIOHBit3OutputCheckBox.Checked;
    HighInputOutputPins.Pin3LowHighState := form1.GPIOHBit3HighCheckBox.Checked;
    HighInputOutputPins.Pin4InputOutputState := form1.GPIOHBit4OutputCheckBox.Checked;
    HighInputOutputPins.Pin4LowHighState := form1.GPIOHBit4HighCheckBox.Checked;
    HighInputOutputPins.Pin5InputOutputState := form1.GPIOHBit5OutputCheckBox.Checked;
    HighInputOutputPins.Pin5LowHighState := form1.GPIOHBit5HighCheckBox.Checked;
    HighInputOutputPins.Pin6InputOutputState := form1.GPIOHBit6OutputCheckBox.Checked;
    HighInputOutputPins.Pin6LowHighState := form1.GPIOHBit6HighCheckBox.Checked;
    HighInputOutputPins.Pin7InputOutputState := form1.GPIOHBit7OutputCheckBox.Checked;
    HighInputOutputPins.Pin7LowHighState := form1.GPIOHBit7HighCheckBox.Checked;
    HighInputOutputPins.Pin8InputOutputState := form1.GPIOHBit8OutputCheckBox.Checked;
    HighInputOutputPins.Pin8LowHighState := form1.GPIOHBit8HighCheckBox.Checked;

    ftStatus := FT2232HJTAG.SetHiSpeedDeviceGPIOs(ftHandle, False, @LowInputOutputPins,
                                                  True, @HighInputOutputPins);

    if (ftStatus = FTC_SUCCESS) then
    begin
      DispMsg('Reading value from GPIOH 1-8');
      ftStatus := FT2232HJTAG.GetHiSpeedDeviceGPIOs(fthandle, False, @LowPinsInputData,
                                                    True, @HighPinsInputData);
      if (ftStatus = FTC_SUCCESS) then
      begin
        ValPin := 0;
        if HighPinsInputData.Pin1LowHighState then
          ValPin := ValPin or $01;
        if HighPinsInputData.Pin2LowHighState then
          ValPin := ValPin or $02;
        if HighPinsInputData.Pin3LowHighState then
          ValPin := ValPin or $04;
        if HighPinsInputData.Pin4LowHighState then
          ValPin := ValPin or $08;
        if HighPinsInputData.Pin5LowHighState then
          ValPin := ValPin or $10;
        if HighPinsInputData.Pin6LowHighState then
          ValPin := ValPin or $20;
        if HighPinsInputData.Pin7LowHighState then
          ValPin := ValPin or $40;
        if HighPinsInputData.Pin8LowHighState then
          ValPin := ValPin or $80;
      end
      else
        DisplayFT2232HJTAGDllError('UpdateHighIO', 'GetHiSpeedDeviceGPIOs', ftStatus);
    end
    else
      DisplayFT2232HJTAGDllError('UpdateHighIO', 'SetHiSpeedDeviceGPIOs', ftStatus);
  end
  else
  begin
  ValPin := 0;
  DirPin := 0;
  
  if form1.GPIOHBit1HighCheckBox.Checked then ValPin := ValPin or $01;
  if form1.GPIOHBit2HighCheckBox.Checked then ValPin := ValPin or $02;
  if form1.GPIOHBit3HighCheckBox.Checked then ValPin := ValPin or $04;
  if form1.GPIOHBit4HighCheckBox.Checked then ValPin := ValPin or $08;
  if form1.GPIOHBit5HighCheckBox.Checked then ValPin := ValPin or $10;
  if form1.GPIOHBit6HighCheckBox.Checked then ValPin := ValPin or $20;
  if form1.GPIOHBit7HighCheckBox.Checked then ValPin := ValPin or $40;
  if form1.GPIOHBit8HighCheckBox.Checked then ValPin := ValPin or $80;

  if form1.GPIOHBit1OutputCheckBox.Checked then DirPin := DirPin or $01;
  if form1.GPIOHBit2OutputCheckBox.Checked then DirPin := DirPin or $02;
  if form1.GPIOHBit3OutputCheckBox.Checked then DirPin := DirPin or $04;
  if form1.GPIOHBit4OutputCheckBox.Checked then DirPin := DirPin or $08;
  if form1.GPIOHBit5OutputCheckBox.Checked then DirPin := DirPin or $10;
  if form1.GPIOHBit6OutputCheckBox.Checked then DirPin := DirPin or $20;
  if form1.GPIOHBit7OutputCheckBox.Checked then DirPin := DirPin or $40;
  if form1.GPIOHBit8OutputCheckBox.Checked then DirPin := DirPin or $80;

  W_HighPins(Valpin,DirPin);
  DispMsg('Reading value from GPIOH 1-8');
  ValPin := R_HighInputs;
  end;
  form1.GPIOHValueReadEdit.Text := intToStr(ValPin); //HexNibToStr(ValPin);
  end
else
  begin
  DispMsg('Device is not open');
  end;
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
form1.Button1.Enabled := false;
form1.Button2.Enabled := false;
form1.Button3.Enabled := false;
form1.Button4.Enabled := false;
form1.Button5.Enabled := false;
form1.GPIOLUpdateLowButton.Enabled := false;
form1.GPIOHUpdateLowButton.Enabled := false;
ScanIn;
form1.Button1.Enabled := true;
form1.Button2.Enabled := true;
form1.Button3.Enabled := true;
form1.Button4.Enabled := true;
form1.Button5.Enabled := true;
form1.GPIOLUpdateLowButton.Enabled := true;
form1.GPIOHUpdateLowButton.Enabled := true;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
form1.Button1.Enabled := false;
form1.Button2.Enabled := false;
form1.Button3.Enabled := false;
form1.Button4.Enabled := false;
form1.Button5.Enabled := false;
form1.GPIOLUpdateLowButton.Enabled := false;
form1.GPIOHUpdateLowButton.Enabled := false;
ScanOut;
form1.Button1.Enabled := true;
form1.Button2.Enabled := true;
form1.Button3.Enabled := true;
form1.Button4.Enabled := true;
form1.Button5.Enabled := true;
form1.GPIOLUpdateLowButton.Enabled := true;
form1.GPIOHUpdateLowButton.Enabled := true;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
form1.Button1.Enabled := false;
form1.Button2.Enabled := false;
form1.Button3.Enabled := false;
form1.Button4.Enabled := false;
form1.Button5.Enabled := false;
form1.GPIOLUpdateLowButton.Enabled := false;
form1.GPIOHUpdateLowButton.Enabled := false;
ScanInOut;
form1.Button1.Enabled := true;
form1.Button2.Enabled := true;
form1.Button3.Enabled := true;
form1.Button4.Enabled := true;
form1.Button5.Enabled := true;
form1.GPIOLUpdateLowButton.Enabled := true;
form1.GPIOHUpdateLowButton.Enabled := true;

end;

procedure TForm1.Button4Click(Sender: TObject);
begin
form1.Button1.Enabled := false;
form1.Button2.Enabled := false;
form1.Button3.Enabled := false;
form1.Button4.Enabled := false;
form1.Button5.Enabled := false;
form1.GPIOLUpdateLowButton.Enabled := false;
form1.GPIOHUpdateLowButton.Enabled := false;
OpenDevice;
form1.Button1.Enabled := true;
form1.Button2.Enabled := true;
form1.Button3.Enabled := true;
form1.Button4.Enabled := true;
form1.Button5.Enabled := true;
form1.GPIOLUpdateLowButton.Enabled := true;
form1.GPIOHUpdateLowButton.Enabled := true;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
form1.Button1.Enabled := false;
form1.Button2.Enabled := false;
form1.Button3.Enabled := false;
form1.Button4.Enabled := false;
form1.Button5.Enabled := false;
form1.GPIOLUpdateLowButton.Enabled := false;
form1.GPIOHUpdateLowButton.Enabled := false;
ClosePort;
DispMsg('Port Closed');
form1.Button1.Enabled := true;
form1.Button2.Enabled := true;
form1.Button3.Enabled := true;
form1.Button4.Enabled := true;
form1.Button5.Enabled := true;
form1.GPIOLUpdateLowButton.Enabled := true;
form1.GPIOHUpdateLowButton.Enabled := true;

end;

procedure TForm1.GPIOLUpdateLowButtonClick(Sender: TObject);
begin
form1.Button1.Enabled := false;
form1.Button2.Enabled := false;
form1.Button3.Enabled := false;
form1.Button4.Enabled := false;
form1.Button5.Enabled := false;
form1.GPIOLUpdateLowButton.Enabled := false;
form1.GPIOHUpdateLowButton.Enabled := false;
UpdateLowIO;
form1.Button1.Enabled := true;
form1.Button2.Enabled := true;
form1.Button3.Enabled := true;
form1.Button4.Enabled := true;
form1.Button5.Enabled := true;
form1.GPIOLUpdateLowButton.Enabled := true;
form1.GPIOHUpdateLowButton.Enabled := true;
end;

procedure TForm1.GPIOHUpdateLowButtonClick(Sender: TObject);
begin
form1.Button1.Enabled := false;
form1.Button2.Enabled := false;
form1.Button3.Enabled := false;
form1.Button4.Enabled := false;
form1.Button5.Enabled := false;
form1.GPIOLUpdateLowButton.Enabled := false;
form1.GPIOHUpdateLowButton.Enabled := false;
UpdateHighIO;
form1.Button1.Enabled := true;
form1.Button2.Enabled := true;
form1.Button3.Enabled := true;
form1.Button4.Enabled := true;
form1.Button5.Enabled := true;
form1.GPIOLUpdateLowButton.Enabled := true;
form1.GPIOHUpdateLowButton.Enabled := true;
end;

procedure TForm1.BufferScanCommandsCheckBoxClick(Sender: TObject);
var
  DeviceHandleIndex: Dword;
begin
  if BufferScanCommandsCheckBox.Checked then
  begin
    Memo1.Clear;

    if PortAIsOpen then
    begin
      JTAGClearDeviceCmdSequence;

      ExecuteButton.Enabled := True;
    end
    else
    begin
      BufferScanCommandsCheckBox.Checked := False;
      
      DispMsg('Device is not open');
    end;
  end
  else
    ExecuteButton.Enabled := False;
end;

procedure TForm1.ExecuteButtonClick(Sender: TObject);
var
  DeviceHandleIndex: Dword;
  DisplayLines: TStringList;
  i: Integer;
begin
  if BufferScanCommandsCheckBox.Checked then
  begin
    for DeviceHandleIndex := 0 to 49 do
    begin
      if (HiSpeedDevices[DeviceHandleIndex].ftHandle <> 0) then
      begin
        DisplayLines := TStringList.Create;

        JTAGExecuteDeviceCommandSequence(DeviceHandleIndex, DisplayLines);

        if (DisplayLines.Count > 0) then
        begin
          for i := 0 to (DisplayLines.Count - 1) do
            DispMsg(DisplayLines[i]);
        end;

        DisplayLines.Free;
      end;
    end;
  end;
end;

procedure TForm1.DeviceNameComboBoxChange(Sender: TObject);
var
  DeviceHandleIndex: Dword;
  DeviceName: String;
begin
  ftHandle := 0;
  
  DeviceName := Form1.DeviceNameComboBox.Items.Strings[Form1.DeviceNameComboBox.ItemIndex];

  for DeviceHandleIndex := 0 to 49 do
  begin
    if (HiSpeedDevices[DeviceHandleIndex].DeviceName = DeviceName) then
      ftHandle := HiSpeedDevices[DeviceHandleIndex].ftHandle;
  end;

  if (HiSpeedDevices[form1.DeviceNameComboBox.ItemIndex].HiSpeedDeviceType = Dword(FT2232H_DEVICE_TYPE)) then
    form1.FT2232HRadioButton.Checked := true
  else
    form1.FT4232HRadioButton.Checked := true;
end;

procedure TForm1.ClockPulsesButtonClick(Sender: TObject);
var
  NumStrValue: String;
  dwNumClockPulses: Dword;
  DisplayLines: TStringList;
  i: Integer;
begin
  NumStrValue := Trim(NumClockPulsesEdit.Text);

  if (NumStrValue <> '') then
  begin
    try
      dwNumClockPulses := StrToInt(NumStrValue);

      DisplayLines := TStringList.Create;

      JTAGGenerateClockPulses(dwNumClockPulses, DisplayLines);

      if (DisplayLines.Count > 0) then
      begin
        for i := 0 to (DisplayLines.Count - 1) do
          DispMsg(DisplayLines[i]);
      end;

      DisplayLines.Free;
    except
      on EConvertError do
      begin
        ShowMessage('Illegal character entered in clock pulses edit field.');
        NumClockPulsesEdit.SetFocus;
      end;
    end;
  end;
end;

end.
